package com.sun.imageio.plugins.common;

import java.io.IOException;
import javax.imageio.stream.ImageInputStream;
import java.awt.Point;
import java.awt.Rectangle;

public class ReaderUtil
{
    public ReaderUtil() {
    }
    
    private static void computeUpdatedPixels(int n, int n2, int n3, int n4, int n5, int n6, int n7, int n8, int n9, int[] array, int n10) {
        int n11 = 0;
        int n12 = -1;
        int n13 = -1;
        int n14 = -1;
        for (int i = 0; i < n8; ++i) {
            int n15 = n7 + i * n9;
            if (n15 >= n && (n15 - n) % n6 == 0) {
                if (n15 >= n + n2) {
                    break;
                }
                int n16 = n3 + (n15 - n) / n6;
                if (n16 >= n4) {
                    if (n16 > n5) {
                        break;
                    }
                    if (n11 == 0) {
                        n12 = n16;
                        n11 = 1;
                    }
                    else if (n13 == -1) {
                        n13 = n16;
                    }
                    n14 = n16;
                }
            }
        }
        array[n10] = n12;
        if (n11 == 0) {
            array[n10 + 2] = 0;
        }
        else {
            array[n10 + 2] = n14 - n12 + 1;
        }
        array[n10 + 4] = Math.max(n13 - n12, 1);
    }
    
    public static int[] computeUpdatedPixels(Rectangle rectangle, Point point, int n, int n2, int n3, int n4, int n5, int n6, int n7, int n8, int n9, int n10, int n11, int n12) {
        int[] array = new int[6];
        computeUpdatedPixels(rectangle.x, rectangle.width, point.x, n, n3, n5, n7, n9, n11, array, 0);
        computeUpdatedPixels(rectangle.y, rectangle.height, point.y, n2, n4, n6, n8, n10, n12, array, 1);
        return array;
    }
    
    public static int readMultiByteInteger(ImageInputStream imageInputStream) throws IOException {
        int n = imageInputStream.readByte();
        int n2 = n & 0x7F;
        while ((n & 0x80) == 0x80) {
            int n3 = n2 << 7;
            n = imageInputStream.readByte();
            n2 = (n3 | (n & 0x7F));
        }
        return n2;
    }
}
